<template>
    <div class="card">
        <div class="card-header">
            Enter form data
        </div>
        <div class="card-body">
            <div class="row mb-3">
                <div v-for="(cell, key) in cells"
                     :key="key"
                     class="col-6">
                    <Board v-model.number="cell.value"
                           :cells="cell.value"
                           :readonly="readonly || cell.readonly">
                        <template v-slot:label>
                            {{ cell.label }}
                        </template>
                        <template v-slot:helper>
                            {{ cell.helper }}
                        </template>
                    </Board>
                </div>
            </div>
            <div class="row mb-3">
                <div v-for="(brick, key) in bricks"
                     :key="key"
                     class="col-6">
                    <Brick v-model.number="brick.value"
                           :brick="brick.value"
                           :readonly="readonly || brick.readonly">
                        <template v-slot:label>
                            {{ brick.label }}
                        </template>
                        <template v-slot:helper>
                            {{ brick.helper }}
                        </template>
                    </Brick>
                </div>
            </div>
            <div class="row mb-3">
                <div class="col-12">
                    <label for="maze-difficulty" class="flex"> Maze difficulty </label>
                    <div class="form-group">
                        <select id="maze-difficulty"
                                v-model.number="difficulty.value"
                                class="form-control"
                                :disabled="readonly">
                            <option v-for="(option , key) in difficulty.options" :key="key">
                                {{ option }}
                            </option>
                        </select>
                        <small id="maze-difficulty-help" class="form-text text-muted text-left">
                            Select maze difficulty. 1 is the hardest solution and 4 is the easiest.
                        </small>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-12">
                    <button type="button"
                            class="btn btn-md btn-light"
                            style="width: 100%"
                            :disabled="readonly"
                            @click="saveInfo">
                        Create maze
                    </button>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import Board from '../components/Board';
import Brick from '../components/Brick';
import Maze from '../services/MazeService';
import Settings from '../services/SettingsService'

export default {
    name: 'Settings',
    components: {Board, Brick},
    props: {
        readonly: {
            type: Boolean,
            default: false
        }
    },

    data: () => ({
        cells: {
            rows: {
                value: 14,
                label: 'Maze rows',
                helper: 'Add how many rows do you want for your maze. Maximum value will be 14 rows and minimum 2 rows',
                readonly: false
            },
            cols: {
                value: 14,
                label: 'Maze cols',
                helper: 'Add how many columns do you want for your maze. Maximum value will be 14 columns and minimum 2 columns.',
                readonly: false
            }
        },
        bricks: {
            width: {
                value: 40,
                label: 'Brick width',
                helper: 'Add width for maze cells. Maximum value will be 40 and minimum 5.',
                readonly: false
            },
            height: {
                value: 40,
                label: 'Brick height',
                helper: 'Add height for maze cells. Maximum value will be 40 and minimum 5.',
                readonly: false
            },
            xStart: {
                value: 0,
                label: 'Row start coordinate',
                helper: 'Add on which row from maze do you want to start. Maximum value will be the value set for rows maze and minimum 0.',
                readonly: false
            },
            yStart: {
                value: 0,
                label: 'Row start coordinate',
                helper: 'Add on which column from maze do you want to start. Maximum value will be the value set for columns maze and minimum 0.',
                readonly: false
            },
            xEnd: {
                value: null,
                label: 'Row finish coordinate',
                helper: 'By default it will be the last row.',
                readonly: true
            },
            yEnd: {
                value: null,
                label: 'Column finish coordinate',
                helper: 'By default it will be the last column.',
                readonly: true
            }
        },
        status: {
            ...Settings.status
        },

        difficulty: {
            value: 3,
            options: [1, 2, 3, 4]
        }
    }),

    watch: {
        'cells.cols.value': function (newValue) {
            if (newValue > 14) {
                return this.cells.cols.value = 14;
            } else if (newValue < 0) {
                return this.cells.cols.value = 0;
            }
        },
        'cells.rows.value': function (newValue) {
            if (newValue > 14) {
                return this.cells.rows.value = 14;
            } else if (newValue < 0) {
                return this.cells.rows.value = 0;
            }
        },

        'bricks.width.value': function (newValue) {
            if (newValue > 40) {
                return this.bricks.width.value = 40;
            }
        },
        'bricks.height.value': function (newValue) {
            if (newValue > 40) {
                return this.bricks.height.value = 40;
            }
        },

        'bricks.xStart.value': function (newValue) {
            if (newValue >= this.cells.cols.value) {
                return this.bricks.xStart.value = 0;
            } else if (newValue === this.bricks.xEnd.value) {
                return this.bricks.xStart.value = this.bricks.xEnd.value - 1
            }
        },
        'bricks.yStart.value': function (newValue) {
            if (newValue > this.cells.rows.value) {
                return this.bricks.yStart.value = 0;
            }
        },

        'bricks.xEnd.value': function (newValue) {
            if (newValue >= this.cells.cols.value) {
                return this.bricks.xEnd.value = this.cells.cols.value - 1;
            } else if (newValue === this.bricks.xStart.value && this.bricks.yEnd.value === this.bricks.yStart.value) {
                return this.bricks.xEnd.value = this.bricks.xStart.value + 1;
            }
        },
        'bricks.yEnd.value': function (newValue) {
            if (newValue >= this.cells.rows.value) {
                return this.bricks.yEnd.value = this.cells.rows.value - 1;
            }

            if (newValue === this.bricks.yStart.value && this.bricks.xEnd.value === this.bricks.xStart.value) {
                return this.bricks.xEnd.value = this.bricks.xStart.value + 1;
            }
        }
    },

    mounted() {
        this.bricks.xEnd.value = this.cells.cols.value - 1;
        this.bricks.yEnd.value = this.cells.rows.value - 1;
    },

    methods: {
        saveInfo() {
            let map = Maze.create(
                [], this.cells.cols.value, this.cells.rows.value, this.bricks.width.value,
                this.bricks.height.value, this.bricks.xStart.value, this.bricks.yStart.value,
                this.bricks.xEnd.value , this.bricks.yEnd.value, this.status.empty.code, this.status.fillBrick.code,
                this.status.start.code, this.status.finish.code, this.difficulty.value
            );

            let mazeData = {
                bricks: {
                    width: this.bricks.width.value,
                    height: this.bricks.height.value,
                    xStart: this.bricks.xStart.value,
                    yStart: this.bricks.yStart.value,
                    xEnd: this.bricks.xEnd.value,
                    yEnd: this.bricks.yEnd.value,
                },
                cells: {
                    cols: this.cells.cols.value,
                    rows: this.cells.rows.value
                },
                map
            };

            this.$emit('createMap', mazeData);
        }
    }
}
</script>

<style scoped>

</style>
